commit c22ed544f1f569190b92587eb990ac69c875b2c0
Author: freddy77 <freddy77>
Date:   Fri Mar 7 10:57:54 2008 +0000

    added transaction level support

diff --git a/ChangeLog b/ChangeLog
index 0e5937f..22bac52 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Mar 07 11:57:00 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/.cvsignore:
+	* src/odbc/unittests/Makefile.am:
+	* src/odbc/unittests/transaction2.c(added):
+	- transaction level support
+
 Fri Mar 07 09:55:57 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* doc/tds.html: updated
 
@@ -191,4 +197,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2496 2008/03/07 08:56:34 freddy77 Exp $
+$Id: ChangeLog,v 1.2497 2008/03/07 10:57:54 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 51a0658..190efbc 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.473 2008/02/29 10:54:53 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.474 2008/03/07 10:57:54 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -270,6 +270,40 @@ change_database(TDS_DBC * dbc, char *database, int database_len)
 	ODBC_RETURN_(dbc);
 }
 
+static SQLRETURN
+change_txn(TDS_DBC * dbc, SQLUINTEGER txn_isolation)
+{
+	char query[64];
+	const char *level;
+	TDSSOCKET *tds = dbc->tds_socket;
+
+	if (!tds)
+		ODBC_RETURN(dbc, SQL_ERROR);
+
+	level = "READ COMMITTED";
+	switch (txn_isolation) {
+	case SQL_TXN_READ_UNCOMMITTED:
+		level = "READ UNCOMMITTED";
+		break;
+	case SQL_TXN_REPEATABLE_READ:
+		level = "REPEATABLE READ";
+		break;
+	case SQL_TXN_SERIALIZABLE:
+		level = "SERIALIZABLE";
+		break;
+	}
+	sprintf(query, "SET TRANSACTION ISOLATION LEVEL %s", level);
+
+	if (tds->state == TDS_IDLE)
+		tds->query_timeout = dbc->default_query_timeout;
+	if (tds_submit_query(tds, query) != TDS_SUCCEED)
+		ODBC_RETURN(dbc, SQL_ERROR);
+	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+		ODBC_RETURN(dbc, SQL_ERROR);
+
+	ODBC_RETURN_(dbc);
+}
+
 static void
 odbc_env_change(TDSSOCKET * tds, int type, char *oldval, char *newval)
 {
@@ -323,6 +357,10 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 	if (IS_TDS7_PLUS(dbc->tds_socket))
 		dbc->cursor_support = 1;
 
+	if (dbc->attr.txn_isolation != SQL_TXN_READ_COMMITTED)
+		if (change_txn(dbc, dbc->attr.txn_isolation) != SQL_SUCCESS)
+			ODBC_RETURN_(dbc);
+
 	/* this overwrite any error arrived (wanted behavior, Sybase return error for conversion errors) */
 	ODBC_RETURN(dbc, SQL_SUCCESS);
 }
@@ -5890,7 +5928,10 @@ _SQLSetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLI
 		break;
 #endif
 	case SQL_ATTR_TXN_ISOLATION:
-		dbc->attr.txn_isolation = u_value;
+		if (u_value != dbc->attr.txn_isolation) {
+			if (change_txn(dbc, u_value) == SQL_SUCCESS)
+				dbc->attr.txn_isolation = u_value;
+		}
 		ODBC_RETURN_(dbc);
 		break;
 	case SQL_ATTR_TRANSLATE_LIB:
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index 4d90945..b8adb7f 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -68,3 +68,4 @@ rowset
 cancel
 test64
 wchar
+transaction2
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index f6bb215..6254689 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.73 2008/02/29 10:54:53 freddy77 Exp $
+# $Id: Makefile.am,v 1.74 2008/03/07 10:57:54 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -21,7 +21,7 @@ TESTS		=	\
 			connect2$(EXEEXT) timeout4$(EXEEXT) freeclose$(EXEEXT) \
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
-			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT)
+			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -83,6 +83,7 @@ blob1_SOURCES	= blob1.c common.c common.h
 rowset_SOURCES	= rowset.c common.c common.h
 cancel_SOURCES = cancel.c common.c common.h
 wchar_SOURCES = wchar.c common.c common.h
+transaction2_SOURCES = transaction2.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/transaction2.c b/src/odbc/unittests/transaction2.c
new file mode 100644
index 0000000..c7a0fae
--- /dev/null
+++ b/src/odbc/unittests/transaction2.c
@@ -0,0 +1,205 @@
+#include "common.h"
+#include <assert.h>
+
+/* Test transaction types */
+
+static char software_version[] = "$Id: transaction2.c,v 1.1 2008/03/07 10:57:54 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void
+AutoCommit(int onoff)
+{
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0));
+}
+
+static void
+EndTransaction(SQLSMALLINT type)
+{
+	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, type));
+}
+
+#define SWAP(t,a,b) do { t xyz = a; a = b; b = xyz; } while(0)
+#define SWAP_CONN() do { SWAP(HENV,env,Environment); SWAP(HDBC,dbc,Connection); SWAP(HSTMT,stmt,Statement);} while(0)
+
+static HENV env = SQL_NULL_HENV;
+static HDBC dbc = SQL_NULL_HDBC;
+static HSTMT stmt = SQL_NULL_HSTMT;
+
+static int
+CheckDirtyRead(void)
+{
+	SQLRETURN ret;
+
+	/* transaction 1 try to change a row but not commit */
+	Command(Statement, "UPDATE test_transaction SET t = 'second' WHERE n = 1");
+
+	SWAP_CONN();
+
+	/* second transaction try to fetch uncommited row */
+	ret = CommandWithResult(Statement, "SELECT * FROM test_transaction WHERE t = 'second' AND n = 1");
+	if (ret == SQL_ERROR) {
+		EndTransaction(SQL_ROLLBACK);
+		SWAP_CONN();
+		EndTransaction(SQL_ROLLBACK);
+		return 0;	/* no dirty read */
+	}
+
+	CHK(SQLFetch, (Statement));
+	ret = SQLFetch(Statement);
+	if (ret != SQL_NO_DATA)
+		ODBC_REPORT_ERROR("other rows ??");
+	SQLMoreResults(Statement);
+	EndTransaction(SQL_ROLLBACK);
+	SWAP_CONN();
+	EndTransaction(SQL_ROLLBACK);
+	return 1;
+}
+
+static int
+CheckNonrepeatableRead(void)
+{
+	SQLRETURN ret;
+
+	/* transaction 2 read a row */
+	SWAP_CONN();
+	CHK(CommandWithResult, (Statement, "SELECT * FROM test_transaction WHERE t = 'initial' AND n = 1"));
+	SQLMoreResults(Statement);
+
+	/* transaction 1 change a row and commit */
+	SWAP_CONN();
+	ret = CommandWithResult(Statement, "UPDATE test_transaction SET t = 'second' WHERE n = 1");
+	if (ret == SQL_ERROR) {
+		EndTransaction(SQL_ROLLBACK);
+		SWAP_CONN();
+		EndTransaction(SQL_ROLLBACK);
+		SWAP_CONN();
+		return 0;	/* no dirty read */
+	}
+	EndTransaction(SQL_COMMIT);
+
+	SWAP_CONN();
+
+	/* second transaction try to fetch commited row */
+	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'second' AND n = 1");
+
+	CHK(SQLFetch, (Statement));
+	ret = SQLFetch(Statement);
+	if (ret != SQL_NO_DATA)
+		ODBC_REPORT_ERROR("other rows ??");
+	SQLMoreResults(Statement);
+	EndTransaction(SQL_ROLLBACK);
+	SWAP_CONN();
+	Command(Statement, "UPDATE test_transaction SET t = 'initial' WHERE n = 1");
+	EndTransaction(SQL_COMMIT);
+	return 1;
+}
+
+static int
+CheckPhantom(void)
+{
+	SQLRETURN ret;
+
+	/* transaction 2 read a row */
+	SWAP_CONN();
+	CHK(CommandWithResult, (Statement, "SELECT * FROM test_transaction WHERE t = 'initial'"));
+	SQLMoreResults(Statement);
+
+	/* transaction 1 insert a row that match critera */
+	SWAP_CONN();
+	ret = CommandWithResult(Statement, "INSERT INTO test_transaction(n, t) VALUES(2, 'initial')");
+	if (ret == SQL_ERROR) {
+		EndTransaction(SQL_ROLLBACK);
+		SWAP_CONN();
+		EndTransaction(SQL_ROLLBACK);
+		SWAP_CONN();
+		return 0;	/* no dirty read */
+	}
+	EndTransaction(SQL_COMMIT);
+
+	SWAP_CONN();
+
+	/* second transaction try to fetch commited row */
+	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'initial'");
+
+	CHK(SQLFetch, (Statement));
+	CHK(SQLFetch, (Statement));
+	ret = SQLFetch(Statement);
+	if (ret != SQL_NO_DATA)
+		ODBC_REPORT_ERROR("other rows ??");
+	SQLMoreResults(Statement);
+	EndTransaction(SQL_ROLLBACK);
+	SWAP_CONN();
+	Command(Statement, "DELETE test_transaction WHERE n = 2");
+	EndTransaction(SQL_COMMIT);
+	return 1;
+}
+
+static void
+Test(int txn, const char *expected)
+{
+	int dirty, repeatable, phantom;
+	char buf[128];
+
+	SWAP_CONN();
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(txn), 0));
+	SWAP_CONN();
+
+	dirty = CheckDirtyRead();
+	repeatable = CheckNonrepeatableRead();
+	phantom = CheckPhantom();
+
+	sprintf(buf, "dirty %d non repeatable %d phantom %d", dirty, repeatable, phantom);
+	if (strcmp(buf, expected) != 0) {
+		fprintf(stderr, "detected wrong TXN\nexpected '%s' got '%s'\n", expected, buf);
+		exit(1);
+	}
+}
+
+int
+main(int argc, char *argv[])
+{
+	Connect();
+
+	/* here we can't use temporary table cause we use two connection */
+	Command(Statement, "IF OBJECT_ID('test_transaction') IS NOT NULL DROP TABLE test_transaction");
+	Command(Statement, "CREATE TABLE test_transaction(n NUMERIC(18,0) PRIMARY KEY, t VARCHAR(30))");
+	Command(Statement, "INSERT INTO test_transaction(n, t) VALUES(1, 'initial')");
+
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+
+	/* TODO test returned error */
+#if 0
+	/* SQL error S1009 -- Invalid argument value */
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(SQL_TXN_REPEATABLE_READ | SQL_TXN_READ_COMMITTED), 0));
+#endif
+
+	AutoCommit(SQL_AUTOCOMMIT_OFF);
+
+	/* save this connection and do another */
+	SWAP_CONN();
+
+	Connect();
+
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+	AutoCommit(SQL_AUTOCOMMIT_OFF);
+
+	SWAP_CONN();
+
+	Test(SQL_TXN_READ_UNCOMMITTED, "dirty 1 non repeatable 1 phantom 1");
+	Test(SQL_TXN_READ_COMMITTED, "dirty 0 non repeatable 1 phantom 1");
+	Test(SQL_TXN_REPEATABLE_READ, "dirty 0 non repeatable 0 phantom 1");
+	Test(SQL_TXN_SERIALIZABLE, "dirty 0 non repeatable 0 phantom 0");
+
+	Disconnect();
+
+	SWAP_CONN();
+
+	EndTransaction(SQL_COMMIT);
+
+	/* Sybase do not accept DROP TABLE during a transaction */
+	AutoCommit(SQL_AUTOCOMMIT_ON);
+	Command(Statement, "DROP TABLE test_transaction");
+
+	Disconnect();
+	return 0;
+}

